/*
 File: rule_lhs_phrasesym.cpp
 Date and Time: Fri Jan 30 18:55:23 2015 
*/
#include "rule_lhs_phrase.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_rule_lhs_phrase;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_rule_lhs_phrase::TH_rule_lhs_phrase(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_rule_lhs_phrase;
  NS_rule_lhs_phrase::Crule_lhs_phrase Crule_lhs_phrase_;// parallel-parser's parse table
#define ssPARSE_TABLE Crule_lhs_phrase_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_rule_lhs_phrase::PROC_TH_rule_lhs_phrase(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_rule_lhs_phrase";
  static bool one_time(false);
  static NS_rule_lhs_phrase::Crule_lhs_phrase* NS_rule_lhs_phrase_Crule_lhs_phrase_(0);// parallel-parser's fsm table
  static Parser* NS_rule_lhs_phrase_Crule_lhs_phrase_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_rule_lhs_phrase_Crule_lhs_phrase_ = new NS_rule_lhs_phrase::Crule_lhs_phrase();// parallel-parser's fsm table
    NS_rule_lhs_phrase_Crule_lhs_phrase_parser = new Parser(*NS_rule_lhs_phrase_Crule_lhs_phrase_,Caller_pp);
  }
 proc_parser = NS_rule_lhs_phrase_Crule_lhs_phrase_parser;
#include "wproc_pp_core.h"
}
void 
Crule_lhs_phrase::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rrule_lhs_phrase_:{
       Rrule_lhs_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rrule_lhs_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_lhs_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 4;
    

     sym->sr1();
     return;}
    case rhs1_Rlhs_:{
       Rlhs* sym;
     if(re->rule_ == 0){
       sym = new Rlhs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlhs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlhs_:{
       Rlhs* sym;
     if(re->rule_ == 0){
       sym = new Rlhs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlhs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rpotential_directives_:{
       Rpotential_directives* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rpotential_directives_:{
       Rpotential_directives* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     return;}
    case rhs1_Rmust_directive_phrase_:{
       Rmust_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr1();
     return;}
    case rhs1_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     return;}
    case rhs6_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     return;}
    case rhs7_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr7();
     return;}
    case rhs1_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rmaybe_more_directives_:{
       Rmaybe_more_directives* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_more_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_more_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rmaybe_more_directives_:{
       Rmaybe_more_directives* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_more_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_more_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rmaybe_directive_phrases_:{
       Rmaybe_directive_phrases* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrases(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrases*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rmaybe_directive_phrases_:{
       Rmaybe_directive_phrases* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrases(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrases*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rmaybe_directive_phrase_:{
       Rmaybe_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr1();
     return;}
    case rhs2_Rmaybe_directive_phrase_:{
       Rmaybe_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr2();
     return;}
    case rhs1_Rdirective_phrase_:{
       Rdirective_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr1();
     return;}
    case rhs1_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     return;}
    case rhs6_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     return;}
    case rhs1_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_Rcweb_marker_:{
       Rcweb_marker* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_marker(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_marker*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs1_Rdirective_cweb_k_:{
       Rdirective_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rdirective_cweb_k_:{
       Rdirective_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rdirective_cweb_k_:{
       Rdirective_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs1_Rcweb_k_:{
       Rcweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rcweb_k_:{
       Rcweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    default: return;
   }
}
